;CodeVisionAVR C Compiler V1.24.0 Standard
;(C) Copyright 1998-2003 HP InfoTech s.r.l.
;http://www.hpinfotech.ro
;e-mail:office@hpinfotech.ro

;Chip type           : ATmega32L
;Program type        : Application
;Clock frequency     : 8,000000 MHz
;Memory model        : Small
;Optimize for        : Size
;(s)printf features  : int, width
;(s)scanf features   : long, width
;External SRAM size  : 0
;Data Stack size     : 512 byte(s)
;Heap size           : 0 byte(s)
;Promote char to int : No
;char is unsigned    : Yes
;8 bit enums         : Yes
;Enhanced core instructions    : On
;Automatic register allocation : On

	.LISTMAC
	.EQU UDRE=0x5
	.EQU RXC=0x7
	.EQU USR=0xB
	.EQU UDR=0xC
	.EQU EERE=0x0
	.EQU EEWE=0x1
	.EQU EEMWE=0x2
	.EQU SPSR=0xE
	.EQU SPDR=0xF
	.EQU EECR=0x1C
	.EQU EEDR=0x1D
	.EQU EEARL=0x1E
	.EQU EEARH=0x1F
	.EQU WDTCR=0x21
	.EQU MCUCR=0x35
	.EQU GICR=0x3B
	.EQU SPL=0x3D
	.EQU SPH=0x3E
	.EQU SREG=0x3F

	.DEF R0X0=R0
	.DEF R0X1=R1
	.DEF R0X2=R2
	.DEF R0X3=R3
	.DEF R0X4=R4
	.DEF R0X5=R5
	.DEF R0X6=R6
	.DEF R0X7=R7
	.DEF R0X8=R8
	.DEF R0X9=R9
	.DEF R0XA=R10
	.DEF R0XB=R11
	.DEF R0XC=R12
	.DEF R0XD=R13
	.DEF R0XE=R14
	.DEF R0XF=R15
	.DEF R0X10=R16
	.DEF R0X11=R17
	.DEF R0X12=R18
	.DEF R0X13=R19
	.DEF R0X14=R20
	.DEF R0X15=R21
	.DEF R0X16=R22
	.DEF R0X17=R23
	.DEF R0X18=R24
	.DEF R0X19=R25
	.DEF R0X1A=R26
	.DEF R0X1B=R27
	.DEF R0X1C=R28
	.DEF R0X1D=R29
	.DEF R0X1E=R30
	.DEF R0X1F=R31

	.EQU __se_bit=0x80
	.EQU __sm_mask=0x70
	.EQU __sm_adc_noise_red=0x10
	.EQU __sm_powerdown=0x20
	.EQU __sm_powersave=0x30
	.EQU __sm_standby=0x60
	.EQU __sm_ext_standby=0x70

	.MACRO __CPD1N
	CPI  R30,LOW(@0)
	LDI  R26,HIGH(@0)
	CPC  R31,R26
	LDI  R26,BYTE3(@0)
	CPC  R22,R26
	LDI  R26,BYTE4(@0)
	CPC  R23,R26
	.ENDM

	.MACRO __CPD2N
	CPI  R26,LOW(@0)
	LDI  R30,HIGH(@0)
	CPC  R27,R30
	LDI  R30,BYTE3(@0)
	CPC  R24,R30
	LDI  R30,BYTE4(@0)
	CPC  R25,R30
	.ENDM

	.MACRO __CPWRR
	CP   R@0,R@2
	CPC  R@1,R@3
	.ENDM

	.MACRO __CPWRN
	CPI  R@0,LOW(@2)
	LDI  R30,HIGH(@2)
	CPC  R@1,R30
	.ENDM

	.MACRO __ADDD1N
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	SBCI R22,BYTE3(-@0)
	SBCI R23,BYTE4(-@0)
	.ENDM

	.MACRO __ADDD2N
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	SBCI R24,BYTE3(-@0)
	SBCI R25,BYTE4(-@0)
	.ENDM

	.MACRO __SUBD1N
	SUBI R30,LOW(@0)
	SBCI R31,HIGH(@0)
	SBCI R22,BYTE3(@0)
	SBCI R23,BYTE4(@0)
	.ENDM

	.MACRO __SUBD2N
	SUBI R26,LOW(@0)
	SBCI R27,HIGH(@0)
	SBCI R24,BYTE3(@0)
	SBCI R25,BYTE4(@0)
	.ENDM

	.MACRO __ANDD1N
	ANDI R30,LOW(@0)
	ANDI R31,HIGH(@0)
	ANDI R22,BYTE3(@0)
	ANDI R23,BYTE4(@0)
	.ENDM

	.MACRO __ORD1N
	ORI  R30,LOW(@0)
	ORI  R31,HIGH(@0)
	ORI  R22,BYTE3(@0)
	ORI  R23,BYTE4(@0)
	.ENDM

	.MACRO __DELAY_USB
	LDI  R24,LOW(@0)
__DELAY_USB_LOOP:
	DEC  R24
	BRNE __DELAY_USB_LOOP
	.ENDM

	.MACRO __DELAY_USW
	LDI  R24,LOW(@0)
	LDI  R25,HIGH(@0)
__DELAY_USW_LOOP:
	SBIW R24,1
	BRNE __DELAY_USW_LOOP
	.ENDM

	.MACRO __CLRD1S
	CLR  R30
	STD  Y+@0,R30
	STD  Y+@0+1,R30
	STD  Y+@0+2,R30
	STD  Y+@0+3,R30
	.ENDM

	.MACRO __GETD1S
	LDD  R30,Y+@0
	LDD  R31,Y+@0+1
	LDD  R22,Y+@0+2
	LDD  R23,Y+@0+3
	.ENDM

	.MACRO __PUTD1S
	STD  Y+@0,R30
	STD  Y+@0+1,R31
	STD  Y+@0+2,R22
	STD  Y+@0+3,R23
	.ENDM

	.MACRO __POINTB1MN
	LDI  R30,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW1MN
	LDI  R30,LOW(@0+@1)
	LDI  R31,HIGH(@0+@1)
	.ENDM

	.MACRO __POINTW1FN
	LDI  R30,LOW(2*@0+@1)
	LDI  R31,HIGH(2*@0+@1)
	.ENDM

	.MACRO __POINTB2MN
	LDI  R26,LOW(@0+@1)
	.ENDM

	.MACRO __POINTW2MN
	LDI  R26,LOW(@0+@1)
	LDI  R27,HIGH(@0+@1)
	.ENDM

	.MACRO __GETD1N
	LDI  R30,LOW(@0)
	LDI  R31,HIGH(@0)
	LDI  R22,BYTE3(@0)
	LDI  R23,BYTE4(@0)
	.ENDM

	.MACRO __GETD2N
	LDI  R26,LOW(@0)
	LDI  R27,HIGH(@0)
	LDI  R24,BYTE3(@0)
	LDI  R25,BYTE4(@0)
	.ENDM

	.MACRO __GETD2S
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	LDD  R24,Y+@0+2
	LDD  R25,Y+@0+3
	.ENDM

	.MACRO __GETB1MN
	LDS  R30,@0+@1
	.ENDM

	.MACRO __GETW1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	.ENDM

	.MACRO __GETD1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	LDS  R22,@0+@1+2
	LDS  R23,@0+@1+3
	.ENDM

	.MACRO __GETBRMN
	LDS  R@2,@0+@1
	.ENDM

	.MACRO __GETWRMN
	LDS  R@2,@0+@1
	LDS  R@3,@0+@1+1
	.ENDM

	.MACRO __GETB2MN
	LDS  R26,@0+@1
	.ENDM

	.MACRO __GETW2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	.ENDM

	.MACRO __GETD2MN
	LDS  R26,@0+@1
	LDS  R27,@0+@1+1
	LDS  R24,@0+@1+2
	LDS  R25,@0+@1+3
	.ENDM

	.MACRO __PUTB1MN
	STS  @0+@1,R30
	.ENDM

	.MACRO __PUTW1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	.ENDM

	.MACRO __PUTD1MN
	STS  @0+@1,R30
	STS  @0+@1+1,R31
	STS  @0+@1+2,R22
	STS  @0+@1+3,R23
	.ENDM

	.MACRO __PUTBMRN
	STS  @0+@1,R@2
	.ENDM

	.MACRO __PUTWMRN
	STS  @0+@1,R@2
	STS  @0+@1+1,R@3
	.ENDM

	.MACRO __GETW1R
	MOV  R30,R@0
	MOV  R31,R@1
	.ENDM

	.MACRO __GETW2R
	MOV  R26,R@0
	MOV  R27,R@1
	.ENDM

	.MACRO __GETWRN
	LDI  R@0,LOW(@2)
	LDI  R@1,HIGH(@2)
	.ENDM

	.MACRO __PUTW1R
	MOV  R@0,R30
	MOV  R@1,R31
	.ENDM

	.MACRO __PUTW2R
	MOV  R@0,R26
	MOV  R@1,R27
	.ENDM

	.MACRO __ADDWRN
	SUBI R@0,LOW(-@2)
	SBCI R@1,HIGH(-@2)
	.ENDM

	.MACRO __ADDWRR
	ADD  R@0,R@2
	ADC  R@1,R@3
	.ENDM

	.MACRO __SUBWRN
	SUBI R@0,LOW(@2)
	SBCI R@1,HIGH(@2)
	.ENDM

	.MACRO __SUBWRR
	SUB  R@0,R@2
	SBC  R@1,R@3
	.ENDM

	.MACRO __ANDWRN
	ANDI R@0,LOW(@2)
	ANDI R@1,HIGH(@2)
	.ENDM

	.MACRO __ANDWRR
	AND  R@0,R@2
	AND  R@1,R@3
	.ENDM

	.MACRO __ORWRN
	ORI  R@0,LOW(@2)
	ORI  R@1,HIGH(@2)
	.ENDM

	.MACRO __ORWRR
	OR   R@0,R@2
	OR   R@1,R@3
	.ENDM

	.MACRO __EORWRR
	EOR  R@0,R@2
	EOR  R@1,R@3
	.ENDM

	.MACRO __GETWRS
	LDD  R@0,Y+@2
	LDD  R@1,Y+@2+1
	.ENDM

	.MACRO __PUTWSR
	STD  Y+@2,R@0
	STD  Y+@2+1,R@1
	.ENDM

	.MACRO __MOVEWRR
	MOV  R@0,R@2
	MOV  R@1,R@3
	.ENDM

	.MACRO __INWR
	IN   R@0,@2
	IN   R@1,@2+1
	.ENDM

	.MACRO __OUTWR
	OUT  @2+1,R@1
	OUT  @2,R@0
	.ENDM

	.MACRO __CALL1MN
	LDS  R30,@0+@1
	LDS  R31,@0+@1+1
	ICALL
	.ENDM

	.MACRO __NBST
	BST  R@0,@1
	IN   R30,SREG
	LDI  R31,0x40
	EOR  R30,R31
	OUT  SREG,R30
	.ENDM


	.MACRO __PUTB1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SN
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNS
	LDD  R26,Y+@0
	LDD  R27,Y+@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMN
	LDS  R26,@0
	LDS  R27,@0+1
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	CALL __PUTDP1
	.ENDM

	.MACRO __PUTB1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X,R30
	.ENDM

	.MACRO __PUTW1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1PMNS
	LDS  R26,@0
	LDS  R27,@0+1
	ADIW R26,@1
	CALL __PUTDP1
	.ENDM

	.MACRO __GETB1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R30,Z
	.ENDM

	.MACRO __GETW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R31,Z
	MOV  R30,R0
	.ENDM

	.MACRO __GETD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R0,Z+
	LD   R1,Z+
	LD   R22,Z+
	LD   R23,Z
	MOVW R30,R0
	.ENDM

	.MACRO __GETB2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R26,X
	.ENDM

	.MACRO __GETW2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	.ENDM

	.MACRO __GETD2SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R1,X+
	LD   R24,X+
	LD   R25,X
	MOVW R26,R0
	.ENDM

	.MACRO __GETBRSX
	MOVW R30,R28
	SUBI R30,LOW(-@1)
	SBCI R31,HIGH(-@1)
	LD   R@0,Z
	.ENDM

	.MACRO __GETWRSX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	LD   R@0,Z+
	LD   R@1,Z
	.ENDM

	.MACRO __LSLW8SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	LD   R31,Z
	CLR  R30
	.ENDM

	.MACRO __PUTB1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __CLRW1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __CLRD1SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	CLR  R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z+,R0
	ST   Z,R0
	.ENDM

	.MACRO __PUTB2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R26
	.ENDM

	.MACRO __PUTW2SX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z+,R26
	ST   Z,R27
	.ENDM

	.MACRO __PUTBSRX
	MOVW R30,R28
	SUBI R30,LOW(-@0)
	SBCI R31,HIGH(-@0)
	ST   Z,R@1
	.ENDM

	.MACRO __PUTWSRX
	MOVW R30,R28
	SUBI R30,LOW(-@2)
	SBCI R31,HIGH(-@2)
	ST   Z+,R@0
	ST   Z,R@1
	.ENDM

	.MACRO __PUTB1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X,R30
	.ENDM

	.MACRO __PUTW1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X,R31
	.ENDM

	.MACRO __PUTD1SNX
	MOVW R26,R28
	SUBI R26,LOW(-@0)
	SBCI R27,HIGH(-@0)
	LD   R0,X+
	LD   R27,X
	MOV  R26,R0
	SUBI R26,LOW(-@1)
	SBCI R27,HIGH(-@1)
	ST   X+,R30
	ST   X+,R31
	ST   X+,R22
	ST   X,R23
	.ENDM

	.MACRO __MULBRR
	MULS R@0,R@1
	MOV  R30,R0
	.ENDM

	.MACRO __MULBRRU
	MUL  R@0,R@1
	MOV  R30,R0
	.ENDM

	.CSEG
	.ORG 0

	.INCLUDE "thermI2C.vec"
	.INCLUDE "thermI2C.inc"

__RESET:
	CLI
	CLR  R30
	OUT  EECR,R30

;INTERRUPT VECTORS ARE PLACED
;AT THE START OF FLASH
	LDI  R31,1
	OUT  GICR,R31
	OUT  GICR,R30
	OUT  MCUCR,R30

;DISABLE WATCHDOG
	LDI  R31,0x18
	OUT  WDTCR,R31
	LDI  R31,0x10
	OUT  WDTCR,R31

;CLEAR R2-R14
	LDI  R24,13
	LDI  R26,2
	CLR  R27
__CLEAR_REG:
	ST   X+,R30
	DEC  R24
	BRNE __CLEAR_REG

;CLEAR SRAM
	LDI  R24,LOW(0x800)
	LDI  R25,HIGH(0x800)
	LDI  R26,0x60
__CLEAR_SRAM:
	ST   X+,R30
	SBIW R24,1
	BRNE __CLEAR_SRAM

;GLOBAL VARIABLES INITIALIZATION
	LDI  R30,LOW(__GLOBAL_INI_TBL*2)
	LDI  R31,HIGH(__GLOBAL_INI_TBL*2)
__GLOBAL_INI_NEXT:
	LPM  R0,Z+
	LPM  R1,Z+
	MOVW R22,R30
	MOVW R30,R0
	SBIW R30,0
	BREQ __GLOBAL_INI_END
	LPM  R26,Z+
	LPM  R27,Z+
	LPM  R24,Z+
	LPM  R25,Z+
__GLOBAL_INI_LOOP:
	LPM  R0,Z+
	ST   X+,R0
	SBIW R24,1
	BRNE __GLOBAL_INI_LOOP
	MOVW R30,R22
	RJMP __GLOBAL_INI_NEXT
__GLOBAL_INI_END:

;STACK POINTER INITIALIZATION
	LDI  R30,LOW(0x85F)
	OUT  SPL,R30
	LDI  R30,HIGH(0x85F)
	OUT  SPH,R30

;DATA STACK POINTER INITIALIZATION
	LDI  R28,LOW(0x260)
	LDI  R29,HIGH(0x260)

	JMP  _main

	.ESEG
	.ORG 0

	.DSEG
	.ORG 0x260
;       1 /*********************************************
;       2 This program was produced by the
;       3 CodeWizardAVR V1.24.0 Standard
;       4 Automatic Program Generator
;       5  Copyright 1998-2003 HP InfoTech s.r.l.
;       6 http://www.hpinfotech.ro
;       7 e-mail:office@hpinfotech.ro
;       8 
;       9 Project : Thermomtre I2C
;      10 Version : 1
;      11 Date    : 29/12/2008
;      12 Author  : Philippe Mariano                         
;      13 Company : Lyce Pierre Emile Martin                                
;      14 Comments: 
;      15 Lecture de la temprature dlivr par un DS1621
;      16 Affichage sur un LCD et sur des LED, rglage de la temprature
;      17 minimum affiche
;      18 
;      19 
;      20 Chip type           : ATmega8535
;      21 Program type        : Application
;      22 Clock frequency     : 8,000000 MHz
;      23 Memory model        : Small
;      24 External SRAM size  : 0
;      25 Data Stack size     : 128
;      26 *********************************************/
;      27 
;      28 // ***************************************************************************************
;      29 // -------------------------------------Bibliothques ------------------------------------ 
;      30 #include <mega32.h>
;      31 //#include <mega8535.h>
;      32 #include <stdio.h>  	// contient la fonction sprintf()
;      33 #include <math.h> 	// contient la fonction abs()
;      34 #include <delay.h>  	// contient la fonction delay_ms()  
;      35 // ---------------------------------------------------------------------------------------
;      36 // I2C Bus functions
;      37 #asm
;      38    .equ __i2c_port=0x12
   .equ __i2c_port=0x12
;      39    .equ __sda_bit=3  
   .equ __sda_bit=3  
;      40    .equ __scl_bit=7  
   .equ __scl_bit=7  
;      41 #endasm

;      42 #include <i2c.h>
;      43 
;      44 // DS1621 Thermometer/Thermostat functions
;      45 #include <ds1621.h>
;      46 
;      47 // Alphanumeric LCD Module functions
;      48 #asm
;      49    .equ __lcd_port=0x15
   .equ __lcd_port=0x15
;      50 #endasm

;      51 #include <lcd.h>
;      52 // ***************************************************************************************
;      53 
;      54 // ***************************************************************************************
;      55 // ---------------------- Octets de commande des composants I2C -------------------------- 
;      56 
;      57 // Dtermination de l'octet de commande des LED: 0 1 0 0 A2 A1 A0 0
;      58 #define EcritureLED	0b01000010   					// <---  complter
;      59 
;      60 // Dtermination des octets de commande du SWITCH: 0 1 0 0 A2 A1 A0 R/W			
;      61 #define LectureSWITCH	0b01000101					// <---  complter
;      62 #define InitSWITCH	0b01000100	
;      63 
;      64 // Dtermination de la partie configurable de l'adresse du capteur 
;      65 // temprature (DS1621)
;      66 #define A_DS1621		0                   			// <---  complter
;      67 // ***************************************************************************************
;      68 
;      69 
;      70 // ***************************************************************************************
;      71 // 				Dbut Programme principal
;      72 // ---------------------------------------------------------------------------------------
;      73 void main(void)
;      74 {

	.CSEG
_main:
;      75 // ***************************************************************************************
;      76 // Dclaration des variables locales
;      77 // ---------------------------------------------------------------------------------------
;      78 // type 		nom 		Commentaires  
;      79 // ---------------------------------------------------------------------------------------
;      80 char display_buffer[17];     	// Tampon pour la premire ligne de l'afficheur 
;      81 unsigned char Tmin=0;		// Temprature mini affiche sur les LED    
;      82 int temperature, Ecart;		// Image de la temprature mesure par le DS1621 et
;      83 				// cart entre la temprature mesure et la temprature
;      84 				// mini affiche sur les LED
;      85 unsigned char DipSwitch=0, LED=0xFF;	// Etat du DIP switch et mot de commande des LED
;      86 // ***************************************************************************************
;      87 
;      88 // ***************************************************************************************
;      89 // 				INITIALISATION DES PERIPHERIQUES
;      90 // ***************************************************************************************
;      91 // I2C Bus initialization
;      92 // ---------------------------------------------------------------------------------------
;      93 i2c_init();
	SBIW R28,18
	LDI  R24,1
	CLR  R26
	CLR  R27
	LDI  R30,LOW(_0x4B*2)
	LDI  R31,HIGH(_0x4B*2)
	CALL __INITLOCB
;	display_buffer -> Y+1
;	Tmin -> R16
;	temperature -> R17,R18
;	Ecart -> R19,R20
;	DipSwitch -> R21
;	LED -> Y+0
	LDI  R16,0
	LDI  R21,0
	CALL _i2c_init
;      94 
;      95 // DS1621 Thermometer/Thermostat initialization
;      96 // ---------------------------------------------------------------------------------------
;      97 // tlow: 50C
;      98 // thigh: 55C
;      99 // Tout polarity: 0
;     100 ds1621_init(0,50,55,0);
	CLR  R30
	ST   -Y,R30
	LDI  R30,LOW(50)
	ST   -Y,R30
	LDI  R30,LOW(55)
	ST   -Y,R30
	CLR  R30
	ST   -Y,R30
	CALL _ds1621_init
;     101 
;     102 // LCD module initialization
;     103 // ---------------------------------------------------------------------------------------
;     104 lcd_init(16);
	LDI  R30,LOW(16)
	ST   -Y,R30
	CALL _lcd_init
;     105 
;     106 // Initialisation du port E/S PCF8574 reli au DIP switch
;     107 // ---------------------------------------------------------------------------------------
;     108 i2c_start();    		// Adresse des switchs = 2
	CALL _i2c_start
;     109 i2c_write(InitSWITCH); 		// Ecriture de 0
	LDI  R30,LOW(68)
	CALL SUBOPT_0x0
;     110 i2c_write(0x00); 
	CALL _i2c_write
;     111 i2c_stop();           
	CALL _i2c_stop
;     112 
;     113 // Initialisation du port E/S PCF8574 reli aux LED
;     114 // ---------------------------------------------------------------------------------------
;     115 i2c_start(); 			// Adresse des LED = 1 
	CALL SUBOPT_0x1
;     116 i2c_write(EcritureLED);  	// Ecriture de FF pour teindre les LED
;     117 i2c_write(0xFF); 
	LDI  R30,LOW(255)
	CALL SUBOPT_0x2
;     118 i2c_stop();
;     119 // ***************************************************************************************
;     120 
;     121 
;     122 while (1)
_0x4C:
;     123       {
;     124 // ---------------------------------- Lecture de la temprature ------------------------      
;     125 temperature = ds1621_temperature_10(A_DS1621);       
	CLR  R30
	ST   -Y,R30
	CALL _ds1621_temperature_10
	__PUTW1R 17,18
;     126 
;     127 // ---------------------------------- Lecture du DIP switch ----------------------------      
;     128 	i2c_start();
	CALL _i2c_start
;     129 	i2c_write(LectureSWITCH);       			
	LDI  R30,LOW(69)
	CALL SUBOPT_0x0
;     130 	DipSwitch = i2c_read(0);	
	CALL _i2c_read
	MOV  R21,R30
;     131 	i2c_stop();  
	CALL _i2c_stop
;     132  
;     133 // --------------------------------------Traitement------------------------------------- 
;     134          Tmin = DipSwitch & 0b00011111;      			// <---  complter
	MOV  R30,R21
	ANDI R30,LOW(0x1F)
	MOV  R16,R30
;     135          
;     136          Ecart = temperature/10 - Tmin; 
	CALL SUBOPT_0x3
	MOVW R26,R30
	MOV  R30,R16
	CLR  R31
	CALL __SWAPW12
	SUB  R30,R26
	SBC  R31,R27
	__PUTW1R 19,20
;     137          
;     138 	 if ((( Ecart > 0) || (Ecart == 0)) && ((Ecart < 7) || (Ecart == 7)))
	CLR  R0
	CP   R0,R19
	CPC  R0,R20
	BRLT _0x50
	CLR  R0
	CP   R0,R19
	CPC  R0,R20
	BRNE _0x52
_0x50:
	__CPWRN 19,20,7
	BRLT _0x53
	LDI  R30,LOW(7)
	LDI  R31,HIGH(7)
	CP   R30,R19
	CPC  R31,R20
	BRNE _0x52
_0x53:
	RJMP _0x55
_0x52:
	RJMP _0x4F
_0x55:
;     139  	   {
;     140  	     switch (Ecart)     
	__GETW1R 19,20
;     141 		{     						// <---  complter
;     142  		     case 0: LED = 0b11111110; break;
	SBIW R30,0
	BRNE _0x59
	LDI  R30,LOW(254)
	ST   Y,R30
	RJMP _0x58
;     143  		     case 1: LED = 0b11111100; break;
_0x59:
	CPI  R30,LOW(0x1)
	LDI  R26,HIGH(0x1)
	CPC  R31,R26
	BRNE _0x5A
	LDI  R30,LOW(252)
	ST   Y,R30
	RJMP _0x58
;     144  		     case 2: LED = 0b11111000; break;
_0x5A:
	CPI  R30,LOW(0x2)
	LDI  R26,HIGH(0x2)
	CPC  R31,R26
	BRNE _0x5B
	LDI  R30,LOW(248)
	ST   Y,R30
	RJMP _0x58
;     145  		     case 3: LED = 0b11110000; break;
_0x5B:
	CPI  R30,LOW(0x3)
	LDI  R26,HIGH(0x3)
	CPC  R31,R26
	BRNE _0x5C
	LDI  R30,LOW(240)
	ST   Y,R30
	RJMP _0x58
;     146  		     case 4: LED = 0b11100000; break;
_0x5C:
	CPI  R30,LOW(0x4)
	LDI  R26,HIGH(0x4)
	CPC  R31,R26
	BRNE _0x5D
	LDI  R30,LOW(224)
	ST   Y,R30
	RJMP _0x58
;     147  		     case 5: LED = 0b11000000; break;
_0x5D:
	CPI  R30,LOW(0x5)
	LDI  R26,HIGH(0x5)
	CPC  R31,R26
	BRNE _0x5E
	LDI  R30,LOW(192)
	ST   Y,R30
	RJMP _0x58
;     148  		     case 6: LED = 0b10000000; break;
_0x5E:
	CPI  R30,LOW(0x6)
	LDI  R26,HIGH(0x6)
	CPC  R31,R26
	BRNE _0x5F
	LDI  R30,LOW(128)
	ST   Y,R30
	RJMP _0x58
;     149  		     case 7: LED = 0b00000000; break; 
_0x5F:
	CPI  R30,LOW(0x7)
	LDI  R26,HIGH(0x7)
	CPC  R31,R26
	BRNE _0x58
	CLR  R30
	ST   Y,R30
;     150  		}
_0x58:
;     151  	   }
;     152  	     else
	RJMP _0x61
_0x4F:
;     153  		LED = 0b11111111; 
	LDI  R30,LOW(255)
	ST   Y,R30
_0x61:
;     154          	
;     155 // ----------------------------- Affichage de la temprature-----------------------------
;     156 	i2c_start(); 	// Affichage sur les LED
	CALL SUBOPT_0x1
;     157 	i2c_write(EcritureLED); 
;     158 	i2c_write(LED); 
	LD   R30,Y
	CALL SUBOPT_0x2
;     159 	i2c_stop(); 
;     160          		// Affichage sur le LCD
;     161 	sprintf(display_buffer,"T=%-i.%-u%-cC",temperature/10,abs(temperature%10),0xdf); 
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	__POINTW1FN _74,0
	ST   -Y,R31
	ST   -Y,R30
	CALL SUBOPT_0x3
	CALL __CWD1
	CALL __PUTPARD1
	__GETW2R 17,18
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __MODW21
	ST   -Y,R31
	ST   -Y,R30
	CALL _abs
	CLR  R22
	CLR  R23
	CALL __PUTPARD1
	__GETD1N 0xDF
	CALL __PUTPARD1
	LDI  R24,12
	CALL _sprintf
	ADIW R28,16
;     162       	lcd_clear();
	CALL _lcd_clear
;     163       	lcd_puts(display_buffer);   
	MOVW R30,R28
	ADIW R30,1
	ST   -Y,R31
	ST   -Y,R30
	CALL _lcd_puts
;     164       	delay_ms(1000);    
	LDI  R30,LOW(1000)
	LDI  R31,HIGH(1000)
	ST   -Y,R31
	ST   -Y,R30
	CALL _delay_ms
;     165       };
	RJMP _0x4C
;     166 }
	ADIW R28,18
_0x62:
	RJMP _0x62
;     167 // ---------------------------------------------------------------------------------------
;     168 // 				Fin Programme principal
;     169 // ***************************************************************************************
_getchar:
     sbis usr,rxc
     rjmp _getchar
     in   r30,udr
	RET
_putchar:
     sbis usr,udre
     rjmp _putchar
     ld   r30,y
     out  udr,r30
	ADIW R28,1
	RET
__put_G2:
	put:
	LD   R26,Y
	LDD  R27,Y+1
	CALL __GETW1P
	SBIW R30,0
	BREQ _0x99
	CALL __GETW1P
	ADIW R30,1
	ST   X+,R30
	ST   X,R31
	SBIW R30,1
	MOVW R26,R30
	LDD  R30,Y+2
	ST   X,R30
	RJMP _0x9A
_0x99:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _putchar
_0x9A:
	ADIW R28,3
	RET
__print_G2:
	SBIW R28,6
	CALL __SAVELOCR6
	LDI  R16,0
_0x9C:
	LDD  R30,Y+16
	LDD  R31,Y+16+1
	ADIW R30,1
	STD  Y+16,R30
	STD  Y+16+1,R31
	SBIW R30,1
	LPM  R30,Z
	MOV  R19,R30
	CPI  R30,0
	BRNE PC+3
	JMP _0x9E
	MOV  R30,R16
	CPI  R30,0
	BRNE _0xA2
	CPI  R19,37
	BRNE _0xA3
	LDI  R16,LOW(1)
	RJMP _0xA4
_0xA3:
	CALL SUBOPT_0x4
_0xA4:
	RJMP _0xA1
_0xA2:
	CPI  R30,LOW(0x1)
	BRNE _0xA5
	CPI  R19,37
	BRNE _0xA6
	CALL SUBOPT_0x4
	LDI  R16,LOW(0)
	RJMP _0xA1
_0xA6:
	LDI  R16,LOW(2)
	LDI  R21,LOW(0)
	LDI  R17,LOW(0)
	CPI  R19,45
	BRNE _0xA7
	LDI  R17,LOW(1)
	RJMP _0xA1
_0xA7:
	CPI  R19,43
	BRNE _0xA8
	LDI  R21,LOW(43)
	RJMP _0xA1
_0xA8:
	CPI  R19,32
	BRNE _0xA9
	LDI  R21,LOW(32)
	RJMP _0xA1
_0xA9:
	RJMP _0xAA
_0xA5:
	CPI  R30,LOW(0x2)
	BRNE _0xAB
_0xAA:
	LDI  R20,LOW(0)
	LDI  R16,LOW(3)
	CPI  R19,48
	BRNE _0xAC
	ORI  R17,LOW(128)
	RJMP _0xA1
_0xAC:
	RJMP _0xAD
_0xAB:
	CPI  R30,LOW(0x3)
	BREQ PC+3
	JMP _0xA1
_0xAD:
	CPI  R19,48
	BRLO _0xB0
	CPI  R19,58
	BRLO _0xB1
_0xB0:
	RJMP _0xAF
_0xB1:
	MOV  R26,R20
	LDI  R30,LOW(10)
	MUL  R30,R26
	MOV  R30,R0
	MOV  R20,R30
	MOV  R30,R19
	SUBI R30,LOW(48)
	ADD  R20,R30
	RJMP _0xA1
_0xAF:
	MOV  R30,R19
	CPI  R30,LOW(0x63)
	BRNE _0xB5
	CALL SUBOPT_0x5
	LD   R30,X
	CALL SUBOPT_0x6
	RJMP _0xB6
_0xB5:
	CPI  R30,LOW(0x73)
	BRNE _0xB8
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlen
	MOV  R16,R30
	RJMP _0xB9
_0xB8:
	CPI  R30,LOW(0x70)
	BRNE _0xBB
	CALL SUBOPT_0x5
	CALL SUBOPT_0x7
	CALL _strlenf
	MOV  R16,R30
	ORI  R17,LOW(8)
_0xB9:
	ORI  R17,LOW(2)
	ANDI R17,LOW(127)
	LDI  R18,LOW(0)
	RJMP _0xBC
_0xBB:
	CPI  R30,LOW(0x64)
	BREQ _0xBF
	CPI  R30,LOW(0x69)
	BRNE _0xC0
_0xBF:
	ORI  R17,LOW(4)
	RJMP _0xC1
_0xC0:
	CPI  R30,LOW(0x75)
	BRNE _0xC2
_0xC1:
	LDI  R30,LOW(_tbl10_G2*2)
	LDI  R31,HIGH(_tbl10_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(5)
	RJMP _0xC3
_0xC2:
	CPI  R30,LOW(0x58)
	BRNE _0xC5
	ORI  R17,LOW(8)
	RJMP _0xC6
_0xC5:
	CPI  R30,LOW(0x78)
	BREQ PC+3
	JMP _0xF4
_0xC6:
	LDI  R30,LOW(_tbl16_G2*2)
	LDI  R31,HIGH(_tbl16_G2*2)
	STD  Y+6,R30
	STD  Y+6+1,R31
	LDI  R16,LOW(4)
_0xC3:
	SBRS R17,2
	RJMP _0xC8
	CALL SUBOPT_0x5
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDD  R26,Y+10
	LDD  R27,Y+10+1
	SBIW R26,0
	BRGE _0xC9
	CALL __ANEGW1
	STD  Y+10,R30
	STD  Y+10+1,R31
	LDI  R21,LOW(45)
_0xC9:
	CPI  R21,0
	BREQ _0xCA
	SUBI R16,-LOW(1)
	RJMP _0xCB
_0xCA:
	ANDI R17,LOW(251)
_0xCB:
	RJMP _0xCC
_0xC8:
	CALL SUBOPT_0x5
	CALL __GETW1P
	STD  Y+10,R30
	STD  Y+10+1,R31
_0xCC:
_0xBC:
	SBRC R17,0
	RJMP _0xCD
_0xCE:
	CP   R16,R20
	BRSH _0xD0
	SBRS R17,7
	RJMP _0xD1
	SBRS R17,2
	RJMP _0xD2
	ANDI R17,LOW(251)
	MOV  R19,R21
	SUBI R16,LOW(1)
	RJMP _0xD3
_0xD2:
	LDI  R19,LOW(48)
_0xD3:
	RJMP _0xD4
_0xD1:
	LDI  R19,LOW(32)
_0xD4:
	CALL SUBOPT_0x4
	SUBI R20,LOW(1)
	RJMP _0xCE
_0xD0:
_0xCD:
	MOV  R18,R16
	SBRS R17,1
	RJMP _0xD5
_0xD6:
	CPI  R18,0
	BREQ _0xD8
	SBRS R17,3
	RJMP _0xD9
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,1
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,1
	LPM  R30,Z
	RJMP _0x10E
_0xD9:
	LDD  R26,Y+6
	LDD  R27,Y+6+1
	LD   R30,X+
	STD  Y+6,R26
	STD  Y+6+1,R27
_0x10E:
	ST   -Y,R30
	CALL SUBOPT_0x8
	CPI  R20,0
	BREQ _0xDB
	SUBI R20,LOW(1)
_0xDB:
	SUBI R18,LOW(1)
	RJMP _0xD6
_0xD8:
	RJMP _0xDC
_0xD5:
_0xDE:
	LDI  R19,LOW(48)
	LDD  R30,Y+6
	LDD  R31,Y+6+1
	ADIW R30,2
	STD  Y+6,R30
	STD  Y+6+1,R31
	SBIW R30,2
	CALL __GETW1PF
	STD  Y+8,R30
	STD  Y+8+1,R31
                                      ldd  r26,y+10  ;R26,R27=n
                                      ldd  r27,y+11
                                  calc_digit:
                                      cp   r26,r30
                                      cpc  r27,r31
                                      brlo calc_digit_done
	SUBI R19,-LOW(1)
	                                  sub  r26,r30
	                                  sbc  r27,r31
	                                  brne calc_digit
                                  calc_digit_done:
                                      std  Y+10,r26 ;n=R26,R27
                                      std  y+11,r27
	LDI  R30,LOW(57)
	CP   R30,R19
	BRSH _0xE0
	SBRS R17,3
	RJMP _0xE1
	SUBI R19,-LOW(7)
	RJMP _0xE2
_0xE1:
	SUBI R19,-LOW(39)
_0xE2:
_0xE0:
	SBRC R17,4
	RJMP _0xE4
	LDI  R30,LOW(48)
	CP   R30,R19
	BRLO _0xE6
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	CPI  R26,LOW(0x1)
	LDI  R30,HIGH(0x1)
	CPC  R27,R30
	BRNE _0xE5
_0xE6:
	ORI  R17,LOW(16)
	RJMP _0xE8
_0xE5:
	CP   R20,R18
	BRLO _0xEA
	SBRS R17,0
	RJMP _0xEB
_0xEA:
	RJMP _0xE9
_0xEB:
	LDI  R19,LOW(32)
	SBRS R17,7
	RJMP _0xEC
	LDI  R19,LOW(48)
	ORI  R17,LOW(16)
_0xE8:
	SBRS R17,2
	RJMP _0xED
	ANDI R17,LOW(251)
	ST   -Y,R21
	CALL SUBOPT_0x8
	CPI  R20,0
	BREQ _0xEE
	SUBI R20,LOW(1)
_0xEE:
_0xED:
_0xEC:
_0xE4:
	CALL SUBOPT_0x4
	CPI  R20,0
	BREQ _0xEF
	SUBI R20,LOW(1)
_0xEF:
_0xE9:
	SUBI R18,LOW(1)
	LDD  R26,Y+8
	LDD  R27,Y+8+1
	LDI  R30,LOW(1)
	LDI  R31,HIGH(1)
	CP   R30,R26
	CPC  R31,R27
	BRSH _0xDF
	RJMP _0xDE
_0xDF:
_0xDC:
	SBRS R17,0
	RJMP _0xF0
_0xF1:
	CPI  R20,0
	BREQ _0xF3
	SUBI R20,LOW(1)
	LDI  R30,LOW(32)
	CALL SUBOPT_0x6
	RJMP _0xF1
_0xF3:
_0xF0:
_0xF4:
_0xB6:
	LDI  R16,LOW(0)
_0xA1:
	RJMP _0x9C
_0x9E:
	CALL __LOADLOCR6
	ADIW R28,18
	RET
_sprintf:
	MOV  R15,R24
	SBIW R28,4
	MOVW R26,R28
	CALL __ADDW2R15
	STD  Y+2,R26
	STD  Y+2+1,R27
	MOVW R26,R28
	ADIW R26,6
	CALL __ADDW2R15
	CALL __GETW1P
	ST   Y,R30
	STD  Y+1,R31
	MOVW R26,R28
	ADIW R26,4
	CALL __ADDW2R15
	CALL __GETW1P
	ST   -Y,R31
	ST   -Y,R30
	LDD  R30,Y+4
	LDD  R31,Y+4+1
	ST   -Y,R31
	ST   -Y,R30
	MOVW R30,R28
	ADIW R30,4
	ST   -Y,R31
	ST   -Y,R30
	CALL __print_G2
	LD   R26,Y
	LDD  R27,Y+1
	CLR  R30
	ST   X,R30
	RJMP _0x10C
_ds1621_get_status:
	ST   -Y,R17
	ST   -Y,R16
	CALL SUBOPT_0x9
	CALL SUBOPT_0xA
	CALL SUBOPT_0xB
	CALL _i2c_start
	SUBI R16,-LOW(1)
	ST   -Y,R16
	CALL _i2c_write
	CALL SUBOPT_0xC
	MOV  R17,R30
	CALL _i2c_stop
	MOV  R30,R17
	LDD  R17,Y+1
	LDD  R16,Y+0
	RJMP _0x10D
_ds1621_set_status:
	CALL _i2c_start
	LDD  R30,Y+1
	CALL SUBOPT_0xD
	CALL SUBOPT_0xB
	LD   R30,Y
	CALL SUBOPT_0x2
	ADIW R28,2
	RET
_ds1621_set_temp:
	CALL _i2c_start
	CALL SUBOPT_0x9
	ST   -Y,R30
	CALL _i2c_write
	LDD  R30,Y+1
	ST   -Y,R30
	CALL _i2c_write
	LD   R30,Y
	CALL SUBOPT_0x0
	CALL _i2c_write
	CALL _i2c_stop
_0xF9:
	LDD  R30,Y+2
	ST   -Y,R30
	CALL _ds1621_get_status
	ANDI R30,LOW(0x10)
	BRNE _0xF9
_0x10D:
	ADIW R28,3
	RET
_ds1621_start:
	CALL _i2c_start
	LD   R30,Y
	CALL SUBOPT_0xD
	LDI  R30,LOW(238)
	CALL SUBOPT_0x2
	ADIW R28,1
	RET
_ds1621_init:
	LDD  R30,Y+3
	ST   -Y,R30
	LDD  R30,Y+1
	LSL  R30
	SUBI R30,-LOW(8)
	ST   -Y,R30
	CALL _ds1621_set_status
	LDD  R30,Y+3
	ST   -Y,R30
	LDI  R30,LOW(162)
	ST   -Y,R30
	LDD  R30,Y+4
	CALL SUBOPT_0xE
	LDI  R30,LOW(161)
	ST   -Y,R30
	LDD  R30,Y+3
	CALL SUBOPT_0xE
	CALL _ds1621_start
_0x10C:
	ADIW R28,4
	RET
_ds1621_temperature_10:
	SBIW R28,2
	ST   -Y,R16
	LDD  R30,Y+3
	LSL  R30
	ORI  R30,LOW(0x90)
	CALL SUBOPT_0xA
	LDI  R30,LOW(170)
	ST   -Y,R30
	CALL _i2c_write
	CALL _i2c_start
	SUBI R16,-LOW(1)
	ST   -Y,R16
	CALL _i2c_write
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL _i2c_read
	STD  Y+2,R30
	CALL SUBOPT_0xC
	STD  Y+1,R30
	CALL _i2c_stop
	LDD  R26,Y+1
	LDD  R27,Y+1+1
	LDI  R30,LOW(7)
	CALL __ASRW12
	LDI  R26,LOW(5)
	LDI  R27,HIGH(5)
	CALL __MULW12
	LDD  R16,Y+0
	ADIW R28,4
	RET
    .equ __lcd_direction=__lcd_port-1
    .equ __lcd_pin=__lcd_port-2
    .equ __lcd_rs=0
    .equ __lcd_rd=1
    .equ __lcd_enable=2
    .equ __lcd_busy_flag=7

	.DSEG
__base_y_G5:
	.BYTE 0x4

	.CSEG
__lcd_ready:
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
    cbi   __lcd_port,__lcd_rs     ;RS=0
__lcd_busy:
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r26,__lcd_pin
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
    sbrc  r26,__lcd_busy_flag
    rjmp  __lcd_busy
	RET
__lcd_write_nibble:
    andi  r26,0xf0
    or    r26,r27
    out   __lcd_port,r26          ;write
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    cbi   __lcd_port,__lcd_enable ;EN=0
__lcd_delay:
    ldi   r31,15
__lcd_delay0:
    dec   r31
    brne  __lcd_delay0
    ret
__lcd_write_data:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    ld    r26,y
    swap  r26
    rcall __lcd_write_nibble      ;write LSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
__lcd_read_nibble:
    sbi   __lcd_port,__lcd_enable ;EN=1
    rcall __lcd_delay
    in    r30,__lcd_pin           ;read
    cbi   __lcd_port,__lcd_enable ;EN=0
    rcall __lcd_delay
    andi  r30,0xf0
    ret
_lcd_read_byte0_G5:
    rcall __lcd_delay
    rcall __lcd_read_nibble       ;read MSN
    mov   r26,r30
    rcall __lcd_read_nibble       ;read LSN
    cbi   __lcd_port,__lcd_rd     ;RD=0
    swap  r30
    or    r30,r26
	RET
_lcd_gotoxy:
	CALL __lcd_ready
	LD   R30,Y
	CLR  R31
	SUBI R30,LOW(-__base_y_G5)
	SBCI R31,HIGH(-__base_y_G5)
	LD   R30,Z
	LDD  R26,Y+1
	ADD  R30,R26
	ST   -Y,R30
	CALL __lcd_write_data
	LDD  R4,Y+1
	LDD  R5,Y+0
	ADIW R28,2
	RET
_lcd_clear:
	CALL __lcd_ready
	LDI  R30,LOW(2)
	CALL SUBOPT_0xF
	LDI  R30,LOW(12)
	CALL SUBOPT_0xF
	LDI  R30,LOW(1)
	ST   -Y,R30
	CALL __lcd_write_data
	CLR  R30
	MOV  R5,R30
	MOV  R4,R30
	RET
_lcd_putchar:
    push r30
    push r31
    ld   r26,y
    set
    cpi  r26,10
    breq __lcd_putchar1
    clt
	INC  R4
	CP   R6,R4
	BRSH _0x105
	__lcd_putchar1:
	INC  R5
	CLR  R30
	ST   -Y,R30
	ST   -Y,R5
	CALL _lcd_gotoxy
	brts __lcd_putchar0
_0x105:
    rcall __lcd_ready
    sbi  __lcd_port,__lcd_rs ;RS=1
    ld   r26,y
    st   -y,r26
    rcall __lcd_write_data
__lcd_putchar0:
    pop  r31
    pop  r30
	ADIW R28,1
	RET
_lcd_puts:
    ldd  r31,y+1
    ld   r30,y
__lcd_puts0:
    ld   r26,z+
    tst  r26
    breq __lcd_puts1
    st   -y,r26    
    rcall _lcd_putchar
    rjmp __lcd_puts0
__lcd_puts1:
	ADIW R28,2
	RET
__long_delay_G5:
    clr   r26
    clr   r27
__long_delay0:
    sbiw  r26,1         ;2 cycles
    brne  __long_delay0 ;2 cycles
	RET
__lcd_init_write_G5:
    cbi  __lcd_port,__lcd_rd 	  ;RD=0
    in    r26,__lcd_direction
    ori   r26,0xf7                ;set as output
    out   __lcd_direction,r26
    in    r27,__lcd_port
    andi  r27,0xf
    ld    r26,y
    rcall __lcd_write_nibble      ;RD=0, write MSN
    sbi   __lcd_port,__lcd_rd     ;RD=1
	ADIW R28,1
	RET
_lcd_init:
    cbi   __lcd_port,__lcd_enable ;EN=0
    cbi   __lcd_port,__lcd_rs     ;RS=0
	LDD  R6,Y+0
	LD   R30,Y
	SUBI R30,-LOW(128)
	__PUTB1MN __base_y_G5,2
	LD   R30,Y
	SUBI R30,-LOW(192)
	__PUTB1MN __base_y_G5,3
	CALL SUBOPT_0x10
	CALL SUBOPT_0x10
	CALL SUBOPT_0x10
	CALL __long_delay_G5
	LDI  R30,LOW(32)
	ST   -Y,R30
	CALL __lcd_init_write_G5
	CALL __long_delay_G5
	LDI  R30,LOW(40)
	CALL SUBOPT_0x11
	LDI  R30,LOW(4)
	CALL SUBOPT_0x11
	LDI  R30,LOW(133)
	CALL SUBOPT_0x11
    in    r26,__lcd_direction
    andi  r26,0xf                 ;set as input
    out   __lcd_direction,r26
    sbi   __lcd_port,__lcd_rd     ;RD=1
	CALL _lcd_read_byte0_G5
	CPI  R30,LOW(0x5)
	BREQ _0x10A
	CLR  R30
	RJMP _0x10B
_0x10A:
	CALL __lcd_ready
	LDI  R30,LOW(6)
	ST   -Y,R30
	CALL __lcd_write_data
	CALL _lcd_clear
	LDI  R30,LOW(1)
_0x10B:
	ADIW R28,1
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x0:
	ST   -Y,R30
	CALL _i2c_write
	CLR  R30
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x1:
	CALL _i2c_start
	LDI  R30,LOW(66)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x2:
	ST   -Y,R30
	CALL _i2c_write
	JMP  _i2c_stop

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x3:
	__GETW2R 17,18
	LDI  R30,LOW(10)
	LDI  R31,HIGH(10)
	CALL __DIVW21
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 4 TIMES
SUBOPT_0x4:
	ST   -Y,R19
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 5 TIMES
SUBOPT_0x5:
	LDD  R26,Y+14
	LDD  R27,Y+14+1
	SBIW R26,4
	STD  Y+14,R26
	STD  Y+14+1,R27
	ADIW R26,4
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x6:
	ST   -Y,R30
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x7:
	CALL __GETD1P
	STD  Y+6,R30
	STD  Y+6+1,R31
	ST   -Y,R31
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x8:
	LDD  R30,Y+13
	LDD  R31,Y+13+1
	ST   -Y,R31
	ST   -Y,R30
	JMP  __put_G2

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0x9:
	LDD  R30,Y+2
	LSL  R30
	ORI  R30,LOW(0x90)
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xA:
	MOV  R16,R30
	CALL _i2c_start
	ST   -Y,R16
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xB:
	LDI  R30,LOW(172)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xC:
	CLR  R30
	ST   -Y,R30
	JMP  _i2c_read

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xD:
	LSL  R30
	ORI  R30,LOW(0x90)
	ST   -Y,R30
	JMP  _i2c_write

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xE:
	ST   -Y,R30
	CALL _ds1621_set_temp
	LDD  R30,Y+3
	ST   -Y,R30
	RET

;OPTIMIZER ADDED SUBROUTINE, CALLED 2 TIMES
SUBOPT_0xF:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __lcd_ready

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x10:
	CALL __long_delay_G5
	LDI  R30,LOW(48)
	ST   -Y,R30
	JMP  __lcd_init_write_G5

;OPTIMIZER ADDED SUBROUTINE, CALLED 3 TIMES
SUBOPT_0x11:
	ST   -Y,R30
	CALL __lcd_write_data
	JMP  __long_delay_G5

_abs:
	ld   r30,y+
	ld   r31,y+
	sbiw r30,0
	brpl __abs0
	com  r30
	com  r31
	adiw r30,1
__abs0:
	ret

	.equ __i2c_dir=__i2c_port-1
	.equ __i2c_pin=__i2c_port-2
_i2c_init:
	cbi  __i2c_port,__scl_bit
	cbi  __i2c_port,__sda_bit
	sbi  __i2c_dir,__scl_bit
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay2
_i2c_start:
	cbi  __i2c_dir,__sda_bit
	cbi  __i2c_dir,__scl_bit
	clr  r30
	nop
	sbis __i2c_pin,__sda_bit
	ret
	sbis __i2c_pin,__scl_bit
	ret
	rcall __i2c_delay1
	sbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	sbi  __i2c_dir,__scl_bit
	ldi  r30,1
__i2c_delay1:
	ldi  r22,13
	rjmp __i2c_delay2l
_i2c_stop:
	sbi  __i2c_dir,__sda_bit
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
__i2c_delay2:
	ldi  r22,27
__i2c_delay2l:
	dec  r22
	brne __i2c_delay2l
	ret
_i2c_read:
	ldi  r23,8
__i2c_read0:
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	clc
	sbic __i2c_pin,__sda_bit
	sec
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	rol  r30
	dec  r23
	brne __i2c_read0
	ld   r23,y+
	tst  r23
	brne __i2c_read1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_read2
__i2c_read1:
	sbi  __i2c_dir,__sda_bit
__i2c_read2:
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_delay1

_i2c_write:
	ld   r30,y+
	ldi  r23,8
__i2c_write0:
	lsl  r30
	brcc __i2c_write1
	cbi  __i2c_dir,__sda_bit
	rjmp __i2c_write2
__i2c_write1:
	sbi  __i2c_dir,__sda_bit
__i2c_write2:
	rcall __i2c_delay2
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	sbi  __i2c_dir,__scl_bit
	dec  r23
	brne __i2c_write0
	cbi  __i2c_dir,__sda_bit
	rcall __i2c_delay1
	cbi  __i2c_dir,__scl_bit
	rcall __i2c_delay2
	ldi  r30,1
	sbic __i2c_pin,__sda_bit
	clr  r30
	sbi  __i2c_dir,__scl_bit
	ret

_strlen:
	ld   r26,y+
	ld   r27,y+
	clr  r30
	clr  r31
__strlen0:
	ld   r22,x+
	tst  r22
	breq __strlen1
	adiw r30,1
	rjmp __strlen0
__strlen1:
	ret

_strlenf:
	clr  r26
	clr  r27
	ld   r30,y+
	ld   r31,y+
__strlenf0:
	lpm  r0,z+
	tst  r0
	breq __strlenf1
	adiw r26,1
	rjmp __strlenf0
__strlenf1:
	movw r30,r26
	ret

_delay_ms:
	ld   r30,y+
	ld   r31,y+
	adiw r30,0
	breq __delay_ms1
__delay_ms0:
	__DELAY_USW 0x7D0
	wdr
	sbiw r30,1
	brne __delay_ms0
__delay_ms1:
	ret

__ADDW2R15:
	CLR  R0
	ADD  R26,R15
	ADC  R27,R0
	RET

__ANEGW1:
	COM  R30
	COM  R31
	ADIW R30,1
	RET

__ASRW12:
	TST  R30
	MOV  R0,R30
	MOVW R30,R26
	BREQ __ASRW12R
__ASRW12L:
	ASR  R31
	ROR  R30
	DEC  R0
	BRNE __ASRW12L
__ASRW12R:
	RET

__CWD1:
	CLR  R22
	CLR  R23
	SBRS R31,7
	RET
	SER  R22
	SER  R23
	RET

__MULW12U:
	MUL  R31,R26
	MOV  R31,R0
	MUL  R30,R27
	ADD  R31,R0
	MUL  R30,R26
	MOV  R30,R0
	ADD  R31,R1
	RET

__MULW12:
	RCALL __CHKSIGNW
	RCALL __MULW12U
	BRTC __MULW121
	RCALL __ANEGW1
__MULW121:
	RET

__DIVW21U:
	CLR  R0
	CLR  R1
	LDI  R25,16
__DIVW21U1:
	LSL  R26
	ROL  R27
	ROL  R0
	ROL  R1
	SUB  R0,R30
	SBC  R1,R31
	BRCC __DIVW21U2
	ADD  R0,R30
	ADC  R1,R31
	RJMP __DIVW21U3
__DIVW21U2:
	SBR  R26,1
__DIVW21U3:
	DEC  R25
	BRNE __DIVW21U1
	MOVW R30,R26
	MOVW R26,R0
	RET

__DIVW21:
	RCALL __CHKSIGNW
	RCALL __DIVW21U
	BRTC __DIVW211
	RCALL __ANEGW1
__DIVW211:
	RET

__MODW21:
	CLT
	SBRS R27,7
	RJMP __MODW211
	COM  R26
	COM  R27
	ADIW R26,1
	SET
__MODW211:
	SBRC R31,7
	RCALL __ANEGW1
	RCALL __DIVW21U
	MOVW R30,R26
	BRTC __MODW212
	RCALL __ANEGW1
__MODW212:
	RET

__CHKSIGNW:
	CLT
	SBRS R31,7
	RJMP __CHKSW1
	RCALL __ANEGW1
	SET
__CHKSW1:
	SBRS R27,7
	RJMP __CHKSW2
	COM  R26
	COM  R27
	ADIW R26,1
	BLD  R0,0
	INC  R0
	BST  R0,0
__CHKSW2:
	RET

__GETW1P:
	LD   R30,X+
	LD   R31,X
	SBIW R26,1
	RET

__GETD1P:
	LD   R30,X+
	LD   R31,X+
	LD   R22,X+
	LD   R23,X
	SBIW R26,3
	RET

__GETW1PF:
	LPM  R0,Z+
	LPM  R31,Z
	MOV  R30,R0
	RET

__PUTPARD1:
	ST   -Y,R23
	ST   -Y,R22
	ST   -Y,R31
	ST   -Y,R30
	RET

__SWAPW12:
	MOV  R1,R27
	MOV  R27,R31
	MOV  R31,R1

__SWAPB12:
	MOV  R1,R26
	MOV  R26,R30
	MOV  R30,R1
	RET

__SAVELOCR6:
	ST   -Y,R21
__SAVELOCR5:
	ST   -Y,R20
__SAVELOCR4:
	ST   -Y,R19
__SAVELOCR3:
	ST   -Y,R18
__SAVELOCR2:
	ST   -Y,R17
	ST   -Y,R16
	RET

__LOADLOCR6:
	LDD  R21,Y+5
__LOADLOCR5:
	LDD  R20,Y+4
__LOADLOCR4:
	LDD  R19,Y+3
__LOADLOCR3:
	LDD  R18,Y+2
__LOADLOCR2:
	LDD  R17,Y+1
	LD   R16,Y
	RET

__INITLOCB:
__INITLOCW:
	ADD R26,R28
	ADC R27,R29
__INITLOC0:
	LPM  R0,Z+
	ST   X+,R0
	DEC  R24
	BRNE __INITLOC0
	RET

